Index: trunk/doc/manual/en_US/SDKRef.xml
===================================================================
--- trunk/doc/manual/en_US/SDKRef.xml	(revision 58079)
+++ trunk/doc/manual/en_US/SDKRef.xml	(revision 58080)
@@ -3527,9 +3527,9 @@
 
   <chapter id="dnd">
-    <title>Drag'n Drop</title>
+    <title>Drag and Drop</title>
 
     <para>Since VirtualBox 4.2 it's possible to transfer files from host to the
     Linux guests by dragging files, directories or text from the host into the
-    guest's screen. This is called <emphasis>drag'n drop
+    guest's screen. This is called <emphasis>drag and drop
     (DnD)</emphasis>.</para>
 
@@ -3538,9 +3538,9 @@
     to the host.</para>
 
-    <note><para>Currently only the VirtualBox Manager frontend supports drag'n
+    <note><para>Currently only the VirtualBox Manager frontend supports drag and
       drop.</para></note>
 
     <para>This chapter will show how to use the required interfaces provided
-    by VirtualBox for adding drag'n drop functionality to third-party
+    by VirtualBox for adding drag and drop functionality to third-party
     frontends.</para>
 
@@ -3550,5 +3550,5 @@
       <para>In order to use the interfaces provided by VirtualBox, some basic
       concepts needs to be understood first: To successfully initiate a
-      drag'n drop operation at least two sides needs to be involved, a
+      drag and drop operation at least two sides needs to be involved, a
       <emphasis>source</emphasis> and a <emphasis>target</emphasis>:</para>
 
@@ -4044,8 +4044,8 @@
         </listitem>
 
-        <listitem><para>Drag'n drop APIs were changed as follows:<itemizedlist>
+        <listitem><para>Drag and drop APIs were changed as follows:<itemizedlist>
 
           <listitem>
-            <para>Methods for providing host to guest drag'n drop
+            <para>Methods for providing host to guest drag and drop
               functionality, such as
               <computeroutput>IGuest::dragHGEnter</computeroutput>,
@@ -4061,5 +4061,5 @@
               <link linkend="IGuest__dnDTarget">IGuest::dnDTarget()</link>
               method.</para>
-            <para>Methods for providing guest to host drag'n drop
+            <para>Methods for providing guest to host drag and drop
               functionality, such as
               <computeroutput>IGuest::dragGHPending()</computeroutput>,
Index: trunk/doc/manual/en_US/user_AdvancedTopics.xml
===================================================================
--- trunk/doc/manual/en_US/user_AdvancedTopics.xml	(revision 58079)
+++ trunk/doc/manual/en_US/user_AdvancedTopics.xml	(revision 58080)
@@ -2422,5 +2422,5 @@
           <glossterm><computeroutput>DragAndDrop</computeroutput></glossterm>
           <glossdef>
-            <para>Don't show the <emphasis>Drag'n'Drop</emphasis> menu item in this menu.</para>
+            <para>Don't show the <emphasis>Drag and Drop</emphasis> menu item in this menu.</para>
           </glossdef>
         </glossentry>
Index: trunk/doc/manual/en_US/user_BasicConcepts.xml
===================================================================
--- trunk/doc/manual/en_US/user_BasicConcepts.xml	(revision 58079)
+++ trunk/doc/manual/en_US/user_BasicConcepts.xml	(revision 58080)
@@ -412,16 +412,16 @@
 
           <glossentry>
-            <glossterm>Drag'n'Drop</glossterm>
+            <glossterm>Drag and Drop</glossterm>
             <glossdef>
-              <para>This setting allows to enable support for drag'n drop: Select
+              <para>This setting allows to enable support for drag and drop: Select
               an object (e.g. a file) from the host or guest and directly copy
-              or open it on the guest or host. Multiple per-VM drag'n drop modes
+              or open it on the guest or host. Multiple per-VM drag and drop modes
               allow restricting access in either direction.</para>
 
-              <para>For drag'n drop to work the Guest Additions need to be
+              <para>For drag and drop to work the Guest Additions need to be
               installed on the guest.</para>
 
-              <para><note><para>Drag'n drop is disabled by default. This setting can be
-              changed at any time using the "Drag'n'Drop" menu item in the
+              <para><note><para>Drag and drop is disabled by default. This setting can be
+              changed at any time using the "Drag and Drop" menu item in the
               "Devices" menu of the virtual machine.</para></note></para>
 
@@ -710,5 +710,5 @@
       by enabling nested paging in addition to hardware virtualization. For
       technical details, see <xref linkend="nestedpaging" />.</para>
-      
+
       <para>Starting with version 5.0, VirtualBox provides paravirtualization
       interfaces to improve time-keeping accuracy and performance of guest
Index: trunk/doc/manual/en_US/user_VBoxManage.xml
===================================================================
--- trunk/doc/manual/en_US/user_VBoxManage.xml	(revision 58079)
+++ trunk/doc/manual/en_US/user_VBoxManage.xml	(revision 58080)
@@ -733,5 +733,5 @@
             </para>
           </listitem>
-          
+
           <listitem>
             <para><computeroutput>--biospxedebug on|off</computeroutput>:
@@ -887,5 +887,5 @@
             the name of the NAT network this adapter is connected to.</para>
           </listitem>
-          
+
           <listitem>
             <para><computeroutput>--bridgeadapter&lt;1-N&gt;
@@ -1040,5 +1040,5 @@
 
       <para>The following other hardware settings, such as serial port, audio,
-      clipboard, drag'n drop, monitor and USB settings are available through
+      clipboard, drag and drop, monitor and USB settings are available through
       <computeroutput>VBoxManage modifyvm</computeroutput>:<itemizedlist>
           <listitem>
@@ -1153,5 +1153,5 @@
             <para><computeroutput>--draganddrop
             disabled|hosttoguest|guesttohost|bidirectional</computeroutput>:
-            With this setting, you can select the current drag'n drop mode
+            With this setting, you can select the current drag and drop mode
             being used between the host and the virtual machine;
             see <xref linkend="guestadd-dnd" />. This requires that the Guest
@@ -1418,5 +1418,5 @@
         </itemizedlist></para>
     </sect2>
-    
+
     <sect2 id="vboxmanage-modifyvm-debugging">
       <title>Debugging settings</title>
@@ -1868,5 +1868,5 @@
         <para><computeroutput>draganddrop
         disabled|hosttoguest|guesttohost|bidirectional</computeroutput>:
-        With this setting, you can select the current drag'n drop mode
+        With this setting, you can select the current drag and drop mode
         being used between the host and the virtual machine;
         see <xref linkend="guestadd-dnd" />. This requires that the Guest