Index: trunk/src/VBox/Additions/common/VBoxGuest/VBoxGuest-linux.c
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuest/VBoxGuest-linux.c	(revision 58069)
+++ trunk/src/VBox/Additions/common/VBoxGuest/VBoxGuest-linux.c	(revision 58089)
@@ -56,5 +56,5 @@
 /** The device name. */
 #define DEVICE_NAME             "vboxguest"
-/** The device name for the device node open to everyone.. */
+/** The device name for the device node open to everyone. */
 #define DEVICE_NAME_USER        "vboxuser"
 /** The name of the PCI driver */
@@ -334,10 +334,10 @@
  * @param   iIrq            The IRQ number.
  * @param   pvDevId         The device ID, a pointer to g_DevExt.
- * @param   pvRegs          Register set. Removed in 2.6.19.
- */
-#if LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 19)
-static irqreturn_t vboxguestLinuxISR(int iIrrq, void *pvDevId)
+ * @param   pRegs           Register set. Removed in 2.6.19.
+ */
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 19) && !defined(DOXYGEN_RUNNING)
+static irqreturn_t vboxguestLinuxISR(int iIrq, void *pvDevId)
 #else
-static irqreturn_t vboxguestLinuxISR(int iIrrq, void *pvDevId, struct pt_regs *pRegs)
+static irqreturn_t vboxguestLinuxISR(int iIrq, void *pvDevId, struct pt_regs *pRegs)
 #endif
 {
@@ -742,4 +742,5 @@
  * Device I/O Control entry point.
  *
+ * @param   pInode      Associated inode pointer.
  * @param   pFilp       Associated file pointer.
  * @param   uCmd        The function specified to ioctl().
Index: trunk/src/VBox/Additions/common/VBoxGuest/VBoxGuest-os2.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuest/VBoxGuest-os2.cpp	(revision 58069)
+++ trunk/src/VBox/Additions/common/VBoxGuest/VBoxGuest-os2.cpp	(revision 58089)
@@ -224,6 +224,4 @@
  * @returns VBox status code.
  * @retval  VERR_VERSION_MISMATCH       The VMMDev memory didn't meet our expectations.
- *
- * @param   pDevExt     The device extension.
  */
 static int vboxGuestOS2MapMemory(void)
Index: trunk/src/VBox/Additions/common/VBoxGuest/VBoxGuest-win.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuest/VBoxGuest-win.cpp	(revision 58069)
+++ trunk/src/VBox/Additions/common/VBoxGuest/VBoxGuest-win.cpp	(revision 58089)
@@ -555,5 +555,5 @@
  * Do not delete DevExt here.
  *
- * @param   pDrvObj     Driver object.
+ * @param   pDevObj     Device object.
  */
 NTSTATUS vbgdNtCleanup(PDEVICE_OBJECT pDevObj)
Index: trunk/src/VBox/Additions/common/VBoxGuest/VBoxGuest.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuest/VBoxGuest.cpp	(revision 58069)
+++ trunk/src/VBox/Additions/common/VBoxGuest/VBoxGuest.cpp	(revision 58089)
@@ -502,5 +502,4 @@
  * @returns VBox status code.
  * @param   pDevExt         The device extension.
- * @param   pSession        The session.
  * @param   cBalloonChunks  The new size of the balloon in chunks of 1MB.
  * @param   pfHandleInR3    Where to return the handle-in-ring3 indicator
@@ -727,5 +726,5 @@
  *
  * @param   pDevExt     The device extension.
- * @param   pDevExt     The session.  Can be NULL at unload.
+ * @param   pSession    The session.  Can be NULL at unload.
  */
 static void vgdrvCloseMemBalloon(PVBOXGUESTDEVEXT pDevExt, PVBOXGUESTSESSION pSession)
@@ -1768,4 +1767,5 @@
  *
  * @returns VINF_SUCCESS or VERR_PERMISSION_DENIED.
+ * @param   pDevExt             The device extension.
  * @param   pSession            The calling session.
  * @param   enmType             The request type.
@@ -2459,4 +2459,6 @@
  * @param   cbData              Size of the buffer.
  * @param   pcbDataReturned     Where to store the amount of returned data. Can be NULL.
+ * @param   fUserSession        Copy of VBOXGUESTSESSION::fUserSession for the
+ *                              call.  True normal user, false root user.
  */
 static int vgdrvIoCtl_Log(PVBOXGUESTDEVEXT pDevExt, const char *pch, size_t cbData, size_t *pcbDataReturned, bool fUserSession)
@@ -2956,5 +2958,6 @@
  *
  * @returns VBox status code.
- * @param   fMask       The new mask.
+ * @param   pDevExt             The device extension.
+ * @param   pReq                The request.
  */
 static int vgdrvUpdateCapabilitiesOnHostWithReqAndLock(PVBOXGUESTDEVEXT pDevExt, VMMDevReqGuestCapabilities2 *pReq)
Index: trunk/src/VBox/Additions/common/VBoxGuest/VBoxGuestIDC-unix.c.h
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuest/VBoxGuestIDC-unix.c.h	(revision 58069)
+++ trunk/src/VBox/Additions/common/VBoxGuest/VBoxGuestIDC-unix.c.h	(revision 58089)
@@ -98,5 +98,5 @@
  *
  * @returns VBox error code.
- * @param   pvState             Opaque pointer to the session object.
+ * @param   pvSession           Opaque pointer to the session object.
  */
 DECLEXPORT(int) VBOXCALL VBoxGuestIDCClose(void *pvSession)
Index: trunk/src/VBox/Additions/common/VBoxGuest/VBoxGuestInternal.h
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuest/VBoxGuestInternal.h	(revision 58069)
+++ trunk/src/VBox/Additions/common/VBoxGuest/VBoxGuestInternal.h	(revision 58089)
@@ -37,5 +37,5 @@
 #include <VBox/VBoxGuestLib.h>
 
-/** @def VBOXGUEST_USE_WAKE_UP_LIST
+/** @def VBOXGUEST_USE_DEFERRED_WAKE_UP
  * Defer wake-up of waiting thread when defined. */
 #if defined(RT_OS_DARWIN) || defined(RT_OS_SOLARIS) || defined(RT_OS_WINDOWS) || defined(DOXYGEN_RUNNING)
@@ -88,5 +88,5 @@
 typedef struct VBOXGUESTMEMBALLOON
 {
-    /** Mutex protecting the members below from concurrent access.. */
+    /** Mutex protecting the members below from concurrent access. */
     RTSEMFASTMUTEX              hMtx;
     /** The current number of chunks in the balloon. */
Index: trunk/src/VBox/Additions/common/VBoxService/VBoxServiceControlProcess.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxService/VBoxServiceControlProcess.cpp	(revision 58069)
+++ trunk/src/VBox/Additions/common/VBoxService/VBoxServiceControlProcess.cpp	(revision 58089)
@@ -224,5 +224,5 @@
  * @return  IPRT status code.
  * @param   pProcess            Process to wait shutting down for.
- * @param   RTMSINTERVAL        Timeout in ms to wait for shutdown.
+ * @param   msTimeout           Timeout in ms to wait for shutdown.
  * @param   prc                 Where to store the thread's return code.
  *                              Optional.
@@ -280,5 +280,5 @@
  *
  * @return  IPRT status code.
- * @param   hPollSet            The polling set.
+ * @param   pProcess            The process which input pipe we close.
  * @param   phStdInW            The standard input pipe handle.
  */
@@ -1405,5 +1405,5 @@
  *
  * @return  IPRT status code.
- * @param   PVBOXSERVICECTRLPROCESS         Guest process.
+ * @param   pProcess        The process we're servicing and monitoring.
  */
 static int vgsvcGstCtrlProcessProcessWorker(PVBOXSERVICECTRLPROCESS pProcess)
@@ -1719,11 +1719,11 @@
  *
  * @return IPRT status code.
- * @param  RTTHREAD             Pointer to the thread's data.
- * @param  void*                User-supplied argument pointer.
- *
- */
-static DECLCALLBACK(int) vgsvcGstCtrlProcessThread(RTTHREAD ThreadSelf, void *pvUser)
-{
-    PVBOXSERVICECTRLPROCESS pProcess = (VBOXSERVICECTRLPROCESS*)pvUser;
+ * @param  hThreadSelf      The thread handle.
+ * @param  pvUser           Pointer to a VBOXSERVICECTRLPROCESS structure.
+ *
+ */
+static DECLCALLBACK(int) vgsvcGstCtrlProcessThread(RTTHREAD hThreadSelf, void *pvUser)
+{
+    PVBOXSERVICECTRLPROCESS pProcess = (PVBOXSERVICECTRLPROCESS)pvUser;
     AssertPtrReturn(pProcess, VERR_INVALID_POINTER);
     return vgsvcGstCtrlProcessProcessWorker(pProcess);
@@ -1748,5 +1748,4 @@
  * @param   pStartupInfo                Startup info.
  * @param   uContextID                  Context ID to associate the process to start with.
-
  */
 int VGSvcGstCtrlProcessStart(const PVBOXSERVICECTRLSESSION pSession,
Index: trunk/src/VBox/Additions/common/VBoxService/VBoxServiceControlSession.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxService/VBoxServiceControlSession.cpp	(revision 58069)
+++ trunk/src/VBox/Additions/common/VBoxService/VBoxServiceControlSession.cpp	(revision 58089)
@@ -1592,4 +1592,5 @@
  *
  * @return  VBox status code.
+ * @param   pSession            The guest session.
  * @param   pbAllowed           True if starting (another) guest process
  *                              is allowed, false if not.
Index: trunk/src/VBox/Additions/common/VBoxService/VBoxServicePageSharing.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxService/VBoxServicePageSharing.cpp	(revision 58069)
+++ trunk/src/VBox/Additions/common/VBoxService/VBoxServicePageSharing.cpp	(revision 58089)
@@ -300,5 +300,9 @@
 /**
  * Inspect all loaded modules for the specified process
+ *
  * @param   dwProcessId     Process id
+ * @param   ppNewTree       The module tree we're assembling from modules found
+ *                          in this process.  Modules found are moved from
+ *                          g_pKnownModuleTree or created new.
  */
 static void vgsvcPageSharingInspectModules(DWORD dwProcessId, PAVLPVNODECORE *ppNewTree)
Index: trunk/src/VBox/Additions/common/VBoxService/VBoxServiceToolBox.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxService/VBoxServiceToolBox.cpp	(revision 58069)
+++ trunk/src/VBox/Additions/common/VBoxService/VBoxServiceToolBox.cpp	(revision 58089)
@@ -967,10 +967,12 @@
 
 /**
- * Report the result of a vbox_mktemp operation - either errors to stderr (not
- * machine-readable) or everything to stdout as <name>\0<rc>\0 (machine-
- * readable format).  The message may optionally contain a '%s' for the file
- * name and an %Rrc for the result code in that order.  In future a "verbose"
- * flag may be added, without which nothing will be output in non-machine-
- * readable mode.  Sets prc if rc is a non-success code.
+ * Report the result of a vbox_mktemp operation.
+ *
+ * Either errors to stderr (not machine-readable) or everything to stdout as
+ * {name}\0{rc}\0 (machine- readable format).  The message may optionally
+ * contain a '%s' for the file name and an %Rrc for the result code in that
+ * order.  In future a "verbose" flag may be added, without which nothing will
+ * be output in non-machine- readable mode.  Sets prc if rc is a non-success
+ * code.
  */
 static void toolboxMkTempReport(const char *pcszMessage, const char *pcszFile,
Index: trunk/src/VBox/Additions/common/VBoxService/VBoxServiceUtils.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxService/VBoxServiceUtils.cpp	(revision 58069)
+++ trunk/src/VBox/Additions/common/VBoxService/VBoxServiceUtils.cpp	(revision 58089)
@@ -269,4 +269,8 @@
  * @returns VBox status code.
  * @param   pszFilename         ASCII & ANSI & UTF-8 compliant name.
+ * @param   pdwMajor            Where to return the major version number.
+ * @param   pdwMinor            Where to return the minor version number.
+ * @param   pdwBuildNumber      Where to return the build number.
+ * @param   pdwRevisionNumber   Where to return the revision number.
  */
 static int vgsvcUtilGetFileVersion(const char *pszFilename, PDWORD pdwMajor, PDWORD pdwMinor, PDWORD pdwBuildNumber,
@@ -347,5 +351,5 @@
  *
  * @param   pszPath         The base path.
- * @param   pszFilaname     The filename.
+ * @param   pszFilename     The filename.
  * @param   pszVersion      Where to return the version string.
  * @param   cbVersion       The size of the version string buffer. This MUST be
Index: trunk/src/VBox/Additions/common/VBoxService/VBoxServiceVMInfo-win.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxService/VBoxServiceVMInfo-win.cpp	(revision 58069)
+++ trunk/src/VBox/Additions/common/VBoxService/VBoxServiceVMInfo-win.cpp	(revision 58089)
@@ -607,10 +607,10 @@
  * vgsvcVMInfoWinProcessesEnumerate() before.
  *
- * @param   paProcs     What
+ * @param   cProcs      Number of processes in paProcs.
+ * @param   paProcs     The process array.
  */
 static void vgsvcVMInfoWinProcessesFree(DWORD cProcs, PVBOXSERVICEVMINFOPROC paProcs)
 {
     for (DWORD i = 0; i < cProcs; i++)
-    {
         if (paProcs[i].pSid)
         {
@@ -618,6 +618,4 @@
             paProcs[i].pSid = NULL;
         }
-
-    }
     RTMemFree(paProcs);
 }
@@ -627,11 +625,12 @@
  *
  * @returns Number of processes found for a specified session.
- * @param   pSession        The current user's SID.
- * @param   paProcs         The process snapshot.
- * @param   cProcs          The number of processes in the snaphot.
- * @param   puSession       Looked up session number.  Optional.
+ * @param   pSession            The current user's SID.
+ * @param   paProcs             The process snapshot.
+ * @param   cProcs              The number of processes in the snaphot.
+ * @param   puTerminalSession   Where to return terminal session number.
+ *                              Optional.
  */
-static uint32_t vgsvcVMInfoWinSessionHasProcesses(PLUID pSession,
-                                                  PVBOXSERVICEVMINFOPROC const paProcs, DWORD cProcs, PULONG puTerminalSession)
+static uint32_t vgsvcVMInfoWinSessionHasProcesses(PLUID pSession, PVBOXSERVICEVMINFOPROC const paProcs, DWORD cProcs,
+                                                  PULONG puTerminalSession)
 {
     if (!pSession)
@@ -1063,5 +1062,5 @@
  *
  * @returns VBox status code.
- * @param   pCachce         Property cache to use for storing some of the lookup
+ * @param   pCache          Property cache to use for storing some of the lookup
  *                          data in between calls.
  * @param   ppszUserList    Where to store the user list (separated by commas).