Index: /trunk/include/VBox/vmm/dbgf.h
===================================================================
--- /trunk/include/VBox/vmm/dbgf.h	(revision 58124)
+++ /trunk/include/VBox/vmm/dbgf.h	(revision 58125)
@@ -274,5 +274,5 @@
  *
  * @returns VBox status code which must be propagated up to EM if not VINF_SUCCESS.
- * @param   pVCpu     The cross context VM structure.
+ * @param   pVM     The cross context VM structure.
  */
 # ifdef VBOX_STRICT
@@ -495,5 +495,5 @@
  * Info handler, internal version.
  *
- * @param   pVCpu         The cross context VM structure.
+ * @param   pVM         The cross context VM structure.
  * @param   pHlp        Callback functions for doing output.
  * @param   pszArgs     Argument string. Optional and specific to the handler.
Index: /trunk/include/VBox/vmm/em.h
===================================================================
--- /trunk/include/VBox/vmm/em.h	(revision 58124)
+++ /trunk/include/VBox/vmm/em.h	(revision 58125)
@@ -126,5 +126,5 @@
  * @returns true if enabled.
  * @returns false if disabled.
- * @param   pVCpu         The cross context VM structure.
+ * @param   pVM         The cross context VM structure.
  */
 #define EMIsRawRing3Enabled(pVM)            (!(pVM)->fRecompileUser)
@@ -135,5 +135,5 @@
  * @returns true if enabled.
  * @returns false if disabled.
- * @param   pVCpu         The cross context VM structure.
+ * @param   pVM         The cross context VM structure.
  */
 #define EMIsRawRing0Enabled(pVM)            (!(pVM)->fRecompileSupervisor)
@@ -145,5 +145,5 @@
  * @returns true if enabled.
  * @returns false if disabled.
- * @param   pVCpu         The cross context VM structure.
+ * @param   pVM         The cross context VM structure.
  */
 # define EMIsRawRing1Enabled(pVM)           ((pVM)->fRawRing1Enabled)
@@ -157,5 +157,5 @@
  * @returns true if enabled.
  * @returns false if disabled.
- * @param   pVCpu         The cross context VM structure.
+ * @param   pVM         The cross context VM structure.
  */
 #define EMIsHwVirtExecutionEnabled(pVM)     (!(pVM)->fRecompileSupervisor && !(pVM)->fRecompileUser)
@@ -167,5 +167,5 @@
  * @returns true if enabled.
  * @returns false if disabled.
- * @param   pVCpu         The cross context VM structure.
+ * @param   pVM         The cross context VM structure.
  */
 #define EMIsSupervisorCodeRecompiled(pVM) ((pVM)->fRecompileSupervisor)
Index: /trunk/include/VBox/vmm/pdmapi.h
===================================================================
--- /trunk/include/VBox/vmm/pdmapi.h	(revision 58124)
+++ /trunk/include/VBox/vmm/pdmapi.h	(revision 58125)
@@ -101,5 +101,5 @@
  *          Failure will stop the search and return the return code.
  *          Warnings will be ignored and not returned.
- * @param   pVCpu             The cross context VM structure.
+ * @param   pVM             The cross context VM structure.
  * @param   pszFilename     Module filename.
  * @param   pszName         Module name. (short and unique)
Index: /trunk/include/VBox/vmm/pdmasynccompletion.h
===================================================================
--- /trunk/include/VBox/vmm/pdmasynccompletion.h	(revision 58124)
+++ /trunk/include/VBox/vmm/pdmasynccompletion.h	(revision 58125)
@@ -96,5 +96,5 @@
  * Completion callback for internal.
  *
- * @param   pVCpu         The cross context VM structure.
+ * @param   pVM         The cross context VM structure.
  * @param   pvUser      User argument for the task.
  * @param   pvUser2     User argument for the template.
Index: /trunk/include/VBox/vmm/pdmblkcache.h
===================================================================
--- /trunk/include/VBox/vmm/pdmblkcache.h	(revision 58124)
+++ /trunk/include/VBox/vmm/pdmblkcache.h	(revision 58125)
@@ -223,5 +223,5 @@
  *
  * @returns VBox status code.
- * @param   pVCpu                      The cross context VM structure.
+ * @param   pVM                      The cross context VM structure.
  * @param   pDrvIns                  The driver instance.
  * @param   ppBlkCache               Where to store the handle to the block cache.
@@ -241,5 +241,5 @@
  *
  * @returns VBox status code.
- * @param   pVCpu                      The cross context VM structure.
+ * @param   pVM                      The cross context VM structure.
  * @param   pDevIns                  The device instance.
  * @param   ppBlkCache               Where to store the handle to the block cache.
@@ -259,5 +259,5 @@
  *
  * @returns VBox status code.
- * @param   pVCpu                      The cross context VM structure.
+ * @param   pVM                      The cross context VM structure.
  * @param   pUsbIns                  The USB device instance.
  * @param   ppBlkCache               Where to store the handle to the block cache.
@@ -277,5 +277,5 @@
  *
  * @returns VBox status code.
- * @param   pVCpu                      The cross context VM structure.
+ * @param   pVM                      The cross context VM structure.
  * @param   pvUser                   Opaque user data.
  * @param   ppBlkCache               Where to store the handle to the block cache.
@@ -303,5 +303,5 @@
  *
  * @returns nothing.
- * @param   pVCpu             The cross context VM structure.
+ * @param   pVM             The cross context VM structure.
  * @param   pDevIns         The device instance.
  */
@@ -312,5 +312,5 @@
  *
  * @returns nothing.
- * @param   pVCpu             The cross context VM structure.
+ * @param   pVM             The cross context VM structure.
  * @param   pDrvIns         The driver instance.
  */
@@ -321,5 +321,5 @@
  *
  * @returns nothing.
- * @param   pVCpu             The cross context VM structure.
+ * @param   pVM             The cross context VM structure.
  * @param   pUsbIns         The USB device instance.
  */
Index: /trunk/include/VBox/vmm/pdmqueue.h
===================================================================
--- /trunk/include/VBox/vmm/pdmqueue.h	(revision 58124)
+++ /trunk/include/VBox/vmm/pdmqueue.h	(revision 58125)
@@ -107,5 +107,5 @@
  * @returns Success indicator.
  *          If false the item will not be removed and the flushing will stop.
- * @param   pVCpu         The cross context VM structure.
+ * @param   pVM         The cross context VM structure.
  * @param   pItem       The item to consume. Upon return this item will be freed.
  * @remarks No locks will be held, but for now it's safe to assume that only one
Index: /trunk/include/VBox/vmm/pdmsrv.h
===================================================================
--- /trunk/include/VBox/vmm/pdmsrv.h	(revision 58124)
+++ /trunk/include/VBox/vmm/pdmsrv.h	(revision 58125)
@@ -208,5 +208,5 @@
      *
      * @returns VBox status.
-     * @param   pVCpu             The cross context VM structure.
+     * @param   pVM             The cross context VM structure.
      * @param   pSrvIns         Service instance.
      * @param   enmClock        The clock to use on this timer.
Index: /trunk/include/VBox/vmm/pdmthread.h
===================================================================
--- /trunk/include/VBox/vmm/pdmthread.h	(revision 58124)
+++ /trunk/include/VBox/vmm/pdmthread.h	(revision 58125)
@@ -121,5 +121,5 @@
  *
  * @returns VBox status code.
- * @param   pVCpu         The cross context VM structure.
+ * @param   pVM         The cross context VM structure.
  * @param   pThread     The PDM thread data.
  */
@@ -177,5 +177,5 @@
  *
  * @returns VBox status code.
- * @param   pVCpu         The cross context VM structure.
+ * @param   pVM         The cross context VM structure.
  * @param   pThread     The PDM thread data.
  */
Index: /trunk/include/VBox/vmm/pgm.h
===================================================================
--- /trunk/include/VBox/vmm/pgm.h	(revision 58124)
+++ /trunk/include/VBox/vmm/pgm.h	(revision 58125)
@@ -168,5 +168,5 @@
  *
  * @returns Strict VBox status code (appropriate for ring-0 and raw-mode).
- * @param   pVCpu         The cross context VM structure.
+ * @param   pVM         The cross context VM structure.
  * @param   pVCpu       The cross context virtual CPU structure of the calling EMT.
  * @param   uErrorCode  CPU Error code.
@@ -198,5 +198,5 @@
  * @retval  VINF_EM_XXX in ring-0 and raw-mode context.
  *
- * @param   pVCpu             The cross context VM structure.
+ * @param   pVM             The cross context VM structure.
  * @param   pVCpu           The cross context virtual CPU structure of the calling EMT.
  * @param   GCPhys          The physical address the guest is writing to.
@@ -237,5 +237,5 @@
  *
  * @returns Strict VBox status code (appropriate for raw-mode).
- * @param   pVCpu             The cross context VM structure.
+ * @param   pVM             The cross context VM structure.
  * @param   pVCpu           The cross context virtual CPU structure of the calling EMT.
  * @param   uErrorCode      CPU Error code (X86_TRAP_PF_XXX).
@@ -261,5 +261,5 @@
  * @returns VINF_SUCCESS if the handler have carried out the operation.
  * @returns VINF_PGM_HANDLER_DO_DEFAULT if the caller should carry out the access operation.
- * @param   pVCpu             The cross context VM structure.
+ * @param   pVM             The cross context VM structure.
  * @param   pVCpu           The cross context virtual CPU structure of the calling EMT.
  * @param   GCPtr           The virtual address the guest is writing to.  This
@@ -282,5 +282,5 @@
  * \#PF Handler callback for invalidation of virtual access handler ranges.
  *
- * @param   pVCpu             The cross context VM structure.
+ * @param   pVM             The cross context VM structure.
  * @param   pVCpu           The cross context virtual CPU structure of the calling EMT.
  * @param   GCPtr           The virtual address the guest has changed.
@@ -300,5 +300,5 @@
  * PGMR3PhysEnumDirtyFTPages callback for syncing dirty physical pages
  *
- * @param   pVCpu             The cross context VM structure.
+ * @param   pVM             The cross context VM structure.
  * @param   GCPhys          GC physical address
  * @param   pRange          HC virtual address of the page(s)
@@ -631,5 +631,5 @@
  *
  * @returns 0 - disabled, 1 - enabled
- * @param   pVCpu         The cross context VM structure.
+ * @param   pVM         The cross context VM structure.
  */
 #define PGMIsUsingLargePages(pVM)   ((pVM)->fUseLargePages)
Index: /trunk/include/VBox/vmm/ssm.h
===================================================================
--- /trunk/include/VBox/vmm/ssm.h	(revision 58124)
+++ /trunk/include/VBox/vmm/ssm.h	(revision 58125)
@@ -815,5 +815,5 @@
  *
  * @returns VBox status code.
- * @param   pVCpu             The cross context VM structure.
+ * @param   pVM             The cross context VM structure.
  * @param   pSSM            SSM operation handle.
  * @thread  Any.
@@ -830,5 +830,5 @@
  *
  * @returns VBox status code.
- * @param   pVCpu             The cross context VM structure.
+ * @param   pVM             The cross context VM structure.
  * @param   pSSM            SSM operation handle.
  * @param   uPass           The data pass.
@@ -852,5 +852,5 @@
  * @retval  VERR_SSM_VOTE_FOR_GIVING_UP if its time to give up.
  *
- * @param   pVCpu             The cross context VM structure.
+ * @param   pVM             The cross context VM structure.
  * @param   pSSM            SSM operation handle.
  * @param   uPass           The data pass.
@@ -865,5 +865,5 @@
  *
  * @returns VBox status code.
- * @param   pVCpu             The cross context VM structure.
+ * @param   pVM             The cross context VM structure.
  * @param   pSSM            SSM operation handle.
  */
@@ -876,5 +876,5 @@
  *
  * @returns VBox status code.
- * @param   pVCpu             The cross context VM structure.
+ * @param   pVM             The cross context VM structure.
  * @param   pSSM            SSM operation handle.
  */
@@ -887,5 +887,5 @@
  *
  * @returns VBox status code.
- * @param   pVCpu             The cross context VM structure.
+ * @param   pVM             The cross context VM structure.
  * @param   pSSM            SSM operation handle.
  */
@@ -898,5 +898,5 @@
  *
  * @returns VBox status code.
- * @param   pVCpu             The cross context VM structure.
+ * @param   pVM             The cross context VM structure.
  * @param   pSSM            SSM operation handle.
  */
@@ -909,5 +909,5 @@
  *
  * @returns VBox status code.
- * @param   pVCpu             The cross context VM structure.
+ * @param   pVM             The cross context VM structure.
  * @param   pSSM            SSM operation handle.
  * @param   uVersion        Data layout version.
@@ -923,5 +923,5 @@
  *
  * @returns VBox load code.
- * @param   pVCpu             The cross context VM structure.
+ * @param   pVM             The cross context VM structure.
  * @param   pSSM            SSM operation handle.
  */
Index: /trunk/include/VBox/vmm/stam.h
===================================================================
--- /trunk/include/VBox/vmm/stam.h	(revision 58124)
+++ /trunk/include/VBox/vmm/stam.h	(revision 58125)
@@ -1113,5 +1113,5 @@
  * Registers a statistics sample.
  *
- * @param   pVCpu         The cross context VM structure.
+ * @param   pVM         The cross context VM structure.
  * @param   pvSample    Pointer to the sample.
  * @param   enmType     Sample type. This indicates what pvSample is pointing at.
@@ -1127,5 +1127,5 @@
  * Registers a statistics sample if statistics are enabled.
  *
- * @param   pVCpu         The cross context VM structure.
+ * @param   pVM         The cross context VM structure.
  * @param   pvSample    Pointer to the sample.
  * @param   enmType     Sample type. This indicates what pvSample is pointing at.
@@ -1141,5 +1141,5 @@
  * Registers a statistics sample which only shows when used.
  *
- * @param   pVCpu         The cross context VM structure.
+ * @param   pVM         The cross context VM structure.
  * @param   pvSample    Pointer to the sample.
  * @param   enmType     Sample type. This indicates what pvSample is pointing at.
@@ -1155,5 +1155,5 @@
  * Registers a statistics sample which only shows when used, if statistics are enabled.
  *
- * @param   pVCpu         The cross context VM structure.
+ * @param   pVM         The cross context VM structure.
  * @param   pvSample    Pointer to the sample.
  * @param   enmType     Sample type. This indicates what pvSample is pointing at.
@@ -1177,5 +1177,5 @@
 /**
  * Resets the sample.
- * @param   pVCpu         The cross context VM structure.
+ * @param   pVM         The cross context VM structure.
  * @param   pvSample    The sample registered using STAMR3RegisterCallback.
  */
@@ -1187,5 +1187,5 @@
  * Prints the sample into the buffer.
  *
- * @param   pVCpu         The cross context VM structure.
+ * @param   pVM         The cross context VM structure.
  * @param   pvSample    The sample registered using STAMR3RegisterCallback.
  * @param   pszBuf      The buffer to print into.
Index: /trunk/include/VBox/vmm/tm.h
===================================================================
--- /trunk/include/VBox/vmm/tm.h	(revision 58124)
+++ /trunk/include/VBox/vmm/tm.h	(revision 58125)
@@ -195,5 +195,5 @@
  * Internal timer callback function.
  *
- * @param   pVCpu             The cross context VM structure.
+ * @param   pVM             The cross context VM structure.
  * @param   pTimer          The timer handle.
  * @param   pvUser          User argument specified upon timer creation.
Index: /trunk/include/VBox/vmm/trpm.h
===================================================================
--- /trunk/include/VBox/vmm/trpm.h	(revision 58124)
+++ /trunk/include/VBox/vmm/trpm.h	(revision 58125)
@@ -125,5 +125,5 @@
  * @returns VBox status code (appropriate for GC return).
  *          In this context VINF_SUCCESS means to restart the instruction.
- * @param   pVCpu         The cross context VM structure.
+ * @param   pVM         The cross context VM structure.
  * @param   pRegFrame   Trap register frame.
  */
Index: /trunk/include/VBox/vmm/vm.h
===================================================================
--- /trunk/include/VBox/vmm/vm.h	(revision 58124)
+++ /trunk/include/VBox/vmm/vm.h	(revision 58125)
@@ -515,5 +515,5 @@
  * Sets a force action flag.
  *
- * @param   pVCpu     The cross context VM structure.
+ * @param   pVM     The cross context VM structure.
  * @param   fFlag   The flag to set.
  */
@@ -538,5 +538,5 @@
  * Clears a force action flag.
  *
- * @param   pVCpu     The cross context VM structure.
+ * @param   pVM     The cross context VM structure.
  * @param   fFlag   The flag to clear.
  */
@@ -561,5 +561,5 @@
  * Checks if a force action flag is set.
  *
- * @param   pVCpu     The cross context VM structure.
+ * @param   pVM     The cross context VM structure.
  * @param   fFlag   The flag to check.
  */
@@ -577,5 +577,5 @@
  * Checks if one or more force action in the specified set is pending.
  *
- * @param   pVCpu     The cross context VM structure.
+ * @param   pVM     The cross context VM structure.
  * @param   fFlags  The flags to check for.
  */
@@ -587,5 +587,5 @@
  * @returns true if the bit was set.
  * @returns false if the bit was clear.
- * @param   pVCpu     The cross context VM structure.
+ * @param   pVM     The cross context VM structure.
  * @param   iBit    Bit position to check and clear
  */
@@ -614,5 +614,5 @@
  * or more other ones are not.
  *
- * @param   pVCpu     The cross context VM structure.
+ * @param   pVM     The cross context VM structure.
  * @param   fFlags  The flags to check for.
  * @param   fExcpt  The flags that should not be set.
Index: /trunk/include/VBox/vmm/vmapi.h
===================================================================
--- /trunk/include/VBox/vmm/vmapi.h	(revision 58124)
+++ /trunk/include/VBox/vmm/vmapi.h	(revision 58125)
@@ -44,5 +44,5 @@
  *
  * @returns raw-mode virtual address.
- * @param   pVCpu     The cross context VM structure.
+ * @param   pVM     The cross context VM structure.
  * @param   pvInVM  CC Pointer within the VM.
  */
@@ -60,5 +60,5 @@
  *
  * @returns host virtual address.
- * @param   pVCpu     The cross context VM structure.
+ * @param   pVM     The cross context VM structure.
  * @param   pvInVM  CC pointer within the VM.
  */
@@ -77,5 +77,5 @@
  *
  * @returns host virtual address.
- * @param   pVCpu     The cross context VM structure.
+ * @param   pVM     The cross context VM structure.
  * @param   pvInVM  CC pointer within the VM.
  */
@@ -116,5 +116,5 @@
  *    return VM_SET_ERROR(pVM, VERR_OF_YOUR_CHOICE, "descriptive message");
  *    @endcode
- * @param   pVCpu             The cross context VM structure.
+ * @param   pVM             The cross context VM structure.
  * @param   rc              VBox status code.
  * @param   pszMessage      Error message string.
@@ -131,5 +131,5 @@
  *    return VM_SET_ERROR(pVM, VERR_OF_YOUR_CHOICE, "descriptive message");
  *    @endcode
- * @param   pVCpu             The cross context VM structure.
+ * @param   pVM             The cross context VM structure.
  * @param   rc              VBox status code.
  * @param   pszMessage      Error message string.
Index: /trunk/include/VBox/vmm/vmm.h
===================================================================
--- /trunk/include/VBox/vmm/vmm.h	(revision 58124)
+++ /trunk/include/VBox/vmm/vmm.h	(revision 58125)
@@ -145,5 +145,5 @@
  *          scheduling.
  *
- * @param   pVCpu     The cross context VM structure.
+ * @param   pVM     The cross context VM structure.
  * @param   pVCpu   The cross context virtual CPU structure of the calling EMT.
  * @param   pvUser  The user argument.