Index: trunk/src/VBox/VMM/include/EMHandleRCTmpl.h
===================================================================
--- trunk/src/VBox/VMM/include/EMHandleRCTmpl.h	(revision 58126)
+++ trunk/src/VBox/VMM/include/EMHandleRCTmpl.h	(revision 58127)
@@ -35,10 +35,10 @@
  * @param   pVM     The cross context VM structure.
  * @param   pVCpu   The cross context virtual CPU structure.
+ * @param   pCtx    Pointer to the guest CPU context.
  * @param   rc      The return code.
- * @param   pCtx    Pointer to the guest CPU context.
  */
 #ifdef EMHANDLERC_WITH_PATM
 int emR3RawHandleRC(PVM pVM, PVMCPU pVCpu, PCPUMCTX pCtx, int rc)
-#elif defined(EMHANDLERC_WITH_HM)
+#elif defined(EMHANDLERC_WITH_HM) || defined(DOXYGEN_RUNNING)
 int emR3HmHandleRC(PVM pVM, PVMCPU pVCpu, PCPUMCTX pCtx, int rc)
 #endif
Index: trunk/src/VBox/VMM/include/GIMKvmInternal.h
===================================================================
--- trunk/src/VBox/VMM/include/GIMKvmInternal.h	(revision 58126)
+++ trunk/src/VBox/VMM/include/GIMKvmInternal.h	(revision 58127)
@@ -197,5 +197,5 @@
     /**  CPUID features: Basic. */
     uint32_t                    uBaseFeat;
-    /** Whether GIM needs to trap #UD exceptions. */
+    /** Whether GIM needs to trap \#UD exceptions. */
     bool                        fTrapXcptUD;
     /** Disassembler opcode of hypercall instruction native for this host CPU. */
Index: trunk/src/VBox/VMM/include/IEMInternal.h
===================================================================
--- trunk/src/VBox/VMM/include/IEMInternal.h	(revision 58126)
+++ trunk/src/VBox/VMM/include/IEMInternal.h	(revision 58127)
@@ -44,5 +44,6 @@
  *    defined(IEM_VERIFICATION_MODE) && !defined(IEM_VERIFICATION_MODE_MINIMAL)
  */
-#if defined(IEM_VERIFICATION_MODE) && !defined(IEM_VERIFICATION_MODE_MINIMAL) && !defined(IEM_VERIFICATION_MODE_FULL)
+#if (defined(IEM_VERIFICATION_MODE) && !defined(IEM_VERIFICATION_MODE_MINIMAL) && !defined(IEM_VERIFICATION_MODE_FULL)) \
+  || defined(DOXYGEN_RUNNING)
 # define IEM_VERIFICATION_MODE_FULL
 #endif
@@ -631,5 +632,6 @@
  * Indicates that one of the verfication modes are enabled.
  */
-#if (defined(IEM_VERIFICATION_MODE_FULL) || defined(IEM_VERIFICATION_MODE_MINIMAL)) && !defined(IEM_VERIFICATION_MODE)
+#if (defined(IEM_VERIFICATION_MODE_FULL) || defined(IEM_VERIFICATION_MODE_MINIMAL)) && !defined(IEM_VERIFICATION_MODE) \
+ || defined(DOXYGEN_RUNNING)
 # define IEM_VERIFICATION_MODE
 #endif
Index: trunk/src/VBox/VMM/include/PDMBlkCacheInternal.h
===================================================================
--- trunk/src/VBox/VMM/include/PDMBlkCacheInternal.h	(revision 58126)
+++ trunk/src/VBox/VMM/include/PDMBlkCacheInternal.h	(revision 58127)
@@ -60,5 +60,5 @@
     /** Cache the entry belongs to. */
     PPDMBLKCACHE                    pBlkCache;
-    /** Flags for this entry. Combinations of PDMACFILECACHE_* #defines */
+    /** Flags for this entry. Combinations of PDMACFILECACHE_* \#defines */
     volatile uint32_t               fFlags;
     /** Reference counter. Prevents eviction of the entry if > 0. */
Index: trunk/src/VBox/VMM/include/PGMInline.h
===================================================================
--- trunk/src/VBox/VMM/include/PGMInline.h	(revision 58126)
+++ trunk/src/VBox/VMM/include/PGMInline.h	(revision 58127)
@@ -225,4 +225,5 @@
  * @param   HCPhys      The physical address of the page.
  * @param   ppv         Where to store the mapping address.
+ * @param   SRC_POS     The source location of the caller.
  */
 DECLINLINE(int) pgmRZDynMapHCPageInlined(PVMCPU pVCpu, RTHCPHYS HCPhys, void **ppv RTLOG_COMMA_SRC_POS_DECL)
@@ -264,4 +265,5 @@
  * @param   GCPhys      The guest physical address of the page.
  * @param   ppv         Where to store the mapping address.
+ * @param   SRC_POS     The source location of the caller.
  */
 DECLINLINE(int) pgmRZDynMapGCPageV2Inlined(PVM pVM, PVMCPU pVCpu, RTGCPHYS GCPhys, void **ppv RTLOG_COMMA_SRC_POS_DECL)
@@ -324,4 +326,5 @@
  * @param   GCPhys      The guest physical address of the page.
  * @param   ppv         Where to store the mapping address.
+ * @param   SRC_POS     The source location of the caller.
  */
 DECLINLINE(int) pgmRZDynMapGCPageInlined(PVMCPU pVCpu, RTGCPHYS GCPhys, void **ppv RTLOG_COMMA_SRC_POS_DECL)
@@ -337,7 +340,8 @@
  * @returns VBox status code, see pgmRZDynMapGCPageCommon for details.
  * @param   pVCpu       The cross context virtual CPU structure.
- * @param   HCPhys      The physical address of the page.
+ * @param   GCPhys      The guest physical address of the page.
  * @param   ppv         Where to store the mapping address. The offset is
  *                      preserved.
+ * @param   SRC_POS     The source location of the caller.
  */
 DECLINLINE(int) pgmRZDynMapGCPageOffInlined(PVMCPU pVCpu, RTGCPHYS GCPhys, void **ppv RTLOG_COMMA_SRC_POS_DECL)
@@ -401,4 +405,5 @@
  * @param   pVM         The cross context VM structure.
  * @param   pPage       The page.
+ * @param   SRC_POS     The source location of the caller.
  */
 DECLINLINE(void *) pgmPoolMapPageInlined(PVM pVM, PPGMPOOLPAGE pPage RTLOG_COMMA_SRC_POS_DECL)
@@ -422,4 +427,5 @@
  * @param   pVCpu       The cross context virtual CPU structure.
  * @param   pPage       The page.
+ * @param   SRC_POS     The source location of the caller.
  */
 DECLINLINE(void *) pgmPoolMapPageV2Inlined(PVM pVM, PVMCPU pVCpu, PPGMPOOLPAGE pPage RTLOG_COMMA_SRC_POS_DECL)
@@ -1073,4 +1079,5 @@
  * @returns Pointer to the shadow PD.
  * @param   pVCpu       The cross context virtual CPU structure.
+ * @param   pPdpt       Pointer to the page directory pointer table.
  * @param   GCPtr       The address.
  */
@@ -1398,5 +1405,5 @@
  * Locks a page to prevent flushing (important for cr3 root pages or shadow pae pd pages).
  *
- * @param   pVM         The cross context VM structure.
+ * @param   pPool       The pool.
  * @param   pPage       PGM pool page
  */
@@ -1411,5 +1418,5 @@
  * Unlocks a page to allow flushing again
  *
- * @param   pVM         The cross context VM structure.
+ * @param   pPool       The pool.
  * @param   pPage       PGM pool page
  */