Index: trunk/src/VBox/Frontends/VirtualBox/src/platform/darwin/VBoxUtils-darwin-cocoa.mm
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/platform/darwin/VBoxUtils-darwin-cocoa.mm	(revision 58140)
+++ trunk/src/VBox/Frontends/VirtualBox/src/platform/darwin/VBoxUtils-darwin-cocoa.mm	(revision 58141)
@@ -165,21 +165,4 @@
             [pButton setEnabled: NO];
     }
-}
-
-void darwinSetHideTitleButtonImpl(NativeNSWindowRef pWindow, CocoaWindowButtonType buttonType)
-{
-    NSButton *pButton = Nil;
-    switch (buttonType)
-    {
-        case CocoaWindowButtonType_Close:            pButton = [pWindow standardWindowButton:NSWindowCloseButton]; break;
-        case CocoaWindowButtonType_Miniaturize:      pButton = [pWindow standardWindowButton:NSWindowMiniaturizeButton]; break;
-        case CocoaWindowButtonType_Zoom:             pButton = [pWindow standardWindowButton:NSWindowZoomButton]; break;
-        case CocoaWindowButtonType_Toolbar:          pButton = [pWindow standardWindowButton:NSWindowToolbarButton]; break;
-        case CocoaWindowButtonType_DocumentIcon:     pButton = [pWindow standardWindowButton:NSWindowDocumentIconButton]; break;
-        case CocoaWindowButtonType_DocumentVersions: /*pButton = [pWindow standardWindowButton:NSWindowDocumentVersionsButton];*/ break;
-        case CocoaWindowButtonType_FullScreen:       /*pButton = [pWindow standardWindowButton:NSWindowFullScreenButton];*/ break;
-    }
-    if (pButton != Nil)
-        [pButton setHidden: YES];
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/platform/darwin/VBoxUtils-darwin.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/platform/darwin/VBoxUtils-darwin.cpp	(revision 58140)
+++ trunk/src/VBox/Frontends/VirtualBox/src/platform/darwin/VBoxUtils-darwin.cpp	(revision 58141)
@@ -77,9 +77,4 @@
     NOREF(pWidget);
 #endif /* !QT_MAC_USE_COCOA */
-}
-
-void darwinSetHideTitleButton(QWidget *pWidget, CocoaWindowButtonType buttonType)
-{
-    ::darwinSetHideTitleButtonImpl(::darwinToNativeWindow(pWidget), buttonType);
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/platform/darwin/VBoxUtils-darwin.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/platform/darwin/VBoxUtils-darwin.h	(revision 58140)
+++ trunk/src/VBox/Frontends/VirtualBox/src/platform/darwin/VBoxUtils-darwin.h	(revision 58141)
@@ -38,16 +38,4 @@
 class QWidget;
 
-/** Cocoa window button types. */
-enum CocoaWindowButtonType
-{
-    CocoaWindowButtonType_Close,            // Since OS X 10.2
-    CocoaWindowButtonType_Miniaturize,      // Since OS X 10.2
-    CocoaWindowButtonType_Zoom,             // Since OS X 10.2
-    CocoaWindowButtonType_Toolbar,          // Since OS X 10.2
-    CocoaWindowButtonType_DocumentIcon,     // Since OS X 10.2
-    CocoaWindowButtonType_DocumentVersions, // Since OS X 10.7
-    CocoaWindowButtonType_FullScreen        // Since OS X 10.7
-};
-
 RT_C_DECLS_BEGIN
 
@@ -70,5 +58,4 @@
 void darwinSetShowsResizeIndicatorImpl(NativeNSWindowRef pWindow, bool fEnabled);
 void darwinSetHidesAllTitleButtonsImpl(NativeNSWindowRef pWindow);
-void darwinSetHideTitleButtonImpl(NativeNSWindowRef pWindow, CocoaWindowButtonType buttonType);
 void darwinLabelWindow(NativeNSWindowRef pWindow, NativeNSImageRef pImage, bool fCenter);
 void darwinSetShowsWindowTransparentImpl(NativeNSWindowRef pWindow, bool fEnabled);
@@ -241,5 +228,4 @@
 void darwinSetShowsResizeIndicator(QWidget *pWidget, bool fEnabled);
 void darwinSetHidesAllTitleButtons(QWidget *pWidget);
-void darwinSetHideTitleButton(QWidget *pWidget, CocoaWindowButtonType buttonType);
 void darwinSetShowsWindowTransparent(QWidget *pWidget, bool fEnabled);
 void darwinSetWindowHasShadow(QWidget *pWidget, bool fEnabled);
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineWindowNormal.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineWindowNormal.cpp	(revision 58140)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineWindowNormal.cpp	(revision 58141)
@@ -304,8 +304,4 @@
         ::darwinLabelWindow(this, &betaLabel, true);
     }
-
-    /* No 'Zoom' button since El Capitan for now: */
-    if (vboxGlobal().osRelease() >= MacOSXRelease_ElCapitan)
-        darwinSetHideTitleButton(this, CocoaWindowButtonType_Zoom);
 #endif /* Q_WS_MAC */
 }
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/scale/UIMachineWindowScale.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/scale/UIMachineWindowScale.cpp	(revision 58140)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/scale/UIMachineWindowScale.cpp	(revision 58141)
@@ -70,8 +70,4 @@
         ::darwinLabelWindow(this, &betaLabel, true);
     }
-
-    /* No 'Zoom' button since El Capitan for now: */
-    if (vboxGlobal().osRelease() >= MacOSXRelease_ElCapitan)
-        darwinSetHideTitleButton(this, CocoaWindowButtonType_Zoom);
 }
 #endif /* Q_WS_MAC */