Index: trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR3LibVideo.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR3LibVideo.cpp	(revision 58154)
+++ trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR3LibVideo.cpp	(revision 58183)
@@ -314,5 +314,5 @@
 
     int rc, rc2 = VERR_UNRESOLVED_ERROR;
-    uint32_t u32ClientId = 0;
+    HGCMCLIENTID idClient = 0;
     const char *pszPattern = VIDEO_PROP_PREFIX"*";
     PVBGLR3GUESTPROPENUM pHandle = NULL;
@@ -321,8 +321,7 @@
 
     AssertPtrReturn(pcScreen, VERR_INVALID_POINTER);
-    rc = VbglR3GuestPropConnect(&u32ClientId);
-    if (RT_SUCCESS(rc))
-        rc = VbglR3GuestPropEnum(u32ClientId, &pszPattern, 1, &pHandle,
-                                 &pszName, NULL, NULL, NULL);
+    rc = VbglR3GuestPropConnect(&idClient);
+    if (RT_SUCCESS(rc))
+        rc = VbglR3GuestPropEnum(idClient, &pszPattern, 1, &pHandle, &pszName, NULL, NULL, NULL);
     if (u32ClientId != 0)
         rc2 = VbglR3GuestPropDisconnect(u32ClientId);
@@ -333,6 +332,5 @@
         uint32_t cScreen;
 
-        rc = RTStrToUInt32Full(pszName + sizeof(VIDEO_PROP_PREFIX) - 1, 10,
-                               &cScreen);
+        rc = RTStrToUInt32Full(pszName + sizeof(VIDEO_PROP_PREFIX) - 1, 10, &cScreen);
         if (RT_SUCCESS(rc))  /* There may be similar properties with text. */
             cHighestScreen = RT_MAX(cHighestScreen, cScreen);
@@ -366,5 +364,5 @@
     using namespace guestProp;
 
-    uint32_t u32ClientId = 0;
+    HGCMCLIENTID idClient = 0;
     unsigned cx2, cy2, cBits2, x2, y2, cHighestScreen, cHighestScreen2;
     bool fEnabled2;
@@ -374,5 +372,5 @@
     rc = VbglR3VideoModeGetHighestSavedScreen(&cHighestScreen);
     if (RT_SUCCESS(rc))
-        rc = VbglR3GuestPropConnect(&u32ClientId);
+        rc = VbglR3GuestPropConnect(&idClient);
     if (RT_SUCCESS(rc))
     {
@@ -382,5 +380,5 @@
         RTStrPrintf(szModeParms, sizeof(szModeParms), "%ux%ux%u,%ux%u,%u", cx, cy, cBits, x, y, (unsigned) fEnabled);
 
-        rc = VbglR3GuestPropWriteValue(u32ClientId, szModeName, szModeParms);
+        rc = VbglR3GuestPropWriteValue(idClient, szModeName, szModeParms);
         /* Write out the mode using the legacy name too, in case the user
          * re-installs older Additions. */
@@ -388,9 +386,9 @@
         {
             RTStrPrintf(szModeParms, sizeof(szModeParms), "%ux%ux%u", cx, cy, cBits);
-            VbglR3GuestPropWriteValue(u32ClientId, VIDEO_PROP_PREFIX "SavedMode", szModeParms);
+            VbglR3GuestPropWriteValue(idClient, VIDEO_PROP_PREFIX "SavedMode", szModeParms);
         }
     }
-    if (u32ClientId != 0)
-        rc2 = VbglR3GuestPropDisconnect(u32ClientId);
+    if (idClient != 0)
+        rc2 = VbglR3GuestPropDisconnect(idClient);
     if (rc == VINF_PERMISSION_DENIED)
         return rc;
@@ -440,12 +438,12 @@
     using namespace guestProp;
 
-/*
- * First we retrieve the video mode which is saved as a string in the
- * guest property store.
- */
+    /*
+     * First we retrieve the video mode which is saved as a string in the
+     * guest property store.
+     */
     /* The buffer for VbglR3GuestPropReadValue.  If this is too small then
      * something is wrong with the data stored in the property. */
     char szModeParms[1024];
-    uint32_t u32ClientId = 0;
+    HGCMCLIENTID idClient = 0;
     int cMatches;
     unsigned cx, cy, cBits;
@@ -456,5 +454,5 @@
     int rc2 = VERR_UNRESOLVED_ERROR;
 
-    rc = VbglR3GuestPropConnect(&u32ClientId);
+    rc = VbglR3GuestPropConnect(&idClient);
     if (RT_SUCCESS(rc))
     {
@@ -462,26 +460,24 @@
         char szModeName[MAX_NAME_LEN];
         RTStrPrintf(szModeName, sizeof(szModeName), VIDEO_PROP_PREFIX "%u", idScreen);
-        rc = VbglR3GuestPropReadValue(u32ClientId, szModeName, szModeParms,
-                                      sizeof(szModeParms), NULL);
+        rc = VbglR3GuestPropReadValue(idClient, szModeName, szModeParms, sizeof(szModeParms), NULL);
         /* Try legacy single screen name. */
         if (rc == VERR_NOT_FOUND && idScreen == 0)
-            rc = VbglR3GuestPropReadValue(u32ClientId,
+            rc = VbglR3GuestPropReadValue(idClient,
                                           VIDEO_PROP_PREFIX"SavedMode",
                                           szModeParms, sizeof(szModeParms),
                                           NULL);
     }
-    if (u32ClientId != 0)
-        rc2 = VbglR3GuestPropDisconnect(u32ClientId);
+    if (idClient != 0)
+        rc2 = VbglR3GuestPropDisconnect(idClient);
     if (RT_SUCCESS(rc))
         rc = rc2;
 
-/*
- * Now we convert the string returned to numeric values.
- */
+    /*
+     * Now we convert the string returned to numeric values.
+     */
     if (RT_SUCCESS(rc))
     {
         char c1, c2;
-        cMatches = sscanf(szModeParms, "%5ux%5ux%2u%c%5ux%5u,%1u%c", &cx, &cy, &cBits,
-                          &c1, &x, &y, &fEnabled, &c2);
+        cMatches = sscanf(szModeParms, "%5ux%5ux%2u%c%5ux%5u,%1u%c", &cx, &cy, &cBits, &c1, &x, &y, &fEnabled, &c2);
         if ((cMatches == 7 && c1 == ',') || cMatches == 3)
             rc = VINF_SUCCESS;
@@ -491,7 +487,8 @@
             rc = VERR_PARSE_ERROR;
     }
-/*
- * And clean up and return the values if we successfully obtained them.
- */
+
+    /*
+     * And clean up and return the values if we successfully obtained them.
+     */
     if (RT_SUCCESS(rc))
     {